<template>
  <q-page padding>
    <q-toolbar class="bg-blue-grey text-white shadow-2 rounded-borders">
      Listado de Lugares
      <q-space />
      <div class="q-gutter-xs">
        <q-btn
          flat
          dense
          icon="control_point"
          label="Nuevo Lugar"
          to="/eventos/lugares/nuevo"
        />
      </div>
    </q-toolbar>

    <q-card class="q-mt-sm">
      <q-table
        :dense="true"
        :rows="dataSet"
        :columns="columnas"
        row-key="uuid"
        v-model:pagination="eventoslugaresStore.filtros"
        :loading="loading"
        @request="onPaginar"
      >
        <!--------------------------------------
            loading
          ---------------------------------------->
        <template v-slot:loading>
          <Loading showing />
        </template>

        <template v-slot:top-left>
          <div class="q-col-gutter-md row">
            <q-input
              dense
              placeholder="Buscar ..."
              v-model="eventoslugaresStore.filtros.query"
              debounce="300"
            >
              <template v-slot:append>
                <q-icon name="search" />
              </template>
            </q-input>

            <q-btn color="green" flat label="Filtrar" @click="onRequest" />
            <q-btn color="blue" flat label="Reset" @click="onResetFiltros" />
          </div>
          <!-- Filtrasr
         tipo => Adultos y Beneficarios.
         rama => en eventos de programa, que permista filtrar la rama en que se anoto
         Otra zona / otro distrito
         por dieta
         -->
        </template>

        <template v-slot:body-cell-opciones="props">
          <q-td :props="props">
            <q-btn
              flat
              color="green"
              size="sm"
              icon="pin_drop"
              :to="'/eventos/lugares/editar/' + props.row.uuid"
            >
              Detalle
            </q-btn>
          </q-td>
        </template>
      </q-table>
    </q-card>
  </q-page>
</template>

<script lang="ts">
import { defineComponent, onMounted, ref } from 'vue';
import { QTableProps } from 'quasar';
import { AxiosResponse } from 'axios';
import { api } from 'src/boot/axios/index';
import { useEventoslugaresStore } from 'src/stores/eventos/lugaresStore';
import Loading from 'src/components/Loading.vue';
// Defino las columnas de la tabla
const columnas: QTableProps['columns'] = [
  { name: 'nombre', label: 'Nombre', field: 'nombre', align: 'left' },
  { name: 'direccion', label: 'Direccion', field: 'direccion', align: 'left' },
  {
    name: 'localidad',
    label: 'localidad',
    field: 'localidad',
    align: 'right',
  },
  { name: 'telefono', label: 'Telefono', field: 'telefono', align: 'center' },
  { name: 'opciones', label: 'Opciones', field: 'opciones', align: 'left' },
];

export default defineComponent({
  components: { Loading },
  name: 'ListadoPage',
  setup() {
    const loading = ref(true);
    const eventoslugaresStore = useEventoslugaresStore();

    onMounted(() => {
      onRequest();
    });

    ////////////////////////////////////////////////////////////////////////////////
    //            GESTION DE PAGINADO Y GESTION DE DATOS
    ////////////////////////////////////////////////////////////////////////////////
    /*********************************************
     *  Metodo onPaginar
     *  Gestiona la configuracion del paginado.
     */
    function onPaginar(props: QTableProps) {
      eventoslugaresStore.setPaginar(props);
      onRequest();
    }

    function onFiltrar() {
      eventoslugaresStore.filtroActivado = true;
      eventoslugaresStore.filtros.page = 1; // siempre que vuelvo a filtra, vuelvo a la pagina 1.
      onRequest();
    }

    /*********************************************
     *  Metoto onRequest
     *  encargado de obtener los datos desde la API
     */
    const dataSet = ref([]);
    function onRequest() {
      loading.value = true;
      api
        .get('/api/eventos/lugar', {
          params: eventoslugaresStore.parametros,
        })
        .then((response: AxiosResponse) => {
          eventoslugaresStore.setRowTotal(response.data.count); // Actializo la cantidas de row, por si cambio
          dataSet.value = response.data.data;
          loading.value = false;
        })
        .catch(() => {
          loading.value = false;
        });
    }

    /*********************************************
     *  Metoto resetFiltros
     *  Reinilizo los Filtros
     */
    function onResetFiltros() {
      eventoslugaresStore.resetFiltros();
      // getCombosEquipos();
      // Recargo la info de la pagina !
      onRequest();
    }

    return {
      columnas,
      dataSet,
      eventoslugaresStore,
      onRequest,
      onPaginar,
      onResetFiltros,
      onFiltrar,
      loading,
    };
  },
});
</script>
